#ifndef __MOVE_H__
#define __MOVE_H__
 
#include "global.h"
#include "PackageList.h"

class Move
{
	private:
		MoveType	mType;
		Money		mBid;
		PackageList	mPackageList;
		Goodness	mGoodness;
	public:
							Move () : mType(NOOP),mBid(1),mGoodness(1) {} ;
							Move (MoveType type, Money bid, PackageList packages): 
								mType(type), mBid(bid), mPackageList(packages), mGoodness(1)  {} ;
							Move (MoveType type, Money bid): mType(type), mBid(bid), mGoodness(1) {} ;
		inline void 		SetType (MoveType type) { mType = type; };
		void 				SetType (Point);
		inline void 		SetBid (Money bid) { mBid = bid; };
		inline void 		SetPackageList (PackageList packages) { mPackageList = packages; }
		inline void 		SetPackageList (Package* package) { mPackageList.RemoveAll(); mPackageList.Add(package); }
		inline void			SetGoodness(Goodness goodness) { mGoodness = goodness; };
		inline MoveType 	GetType () { return mType; };
		inline Money 		GetBid() { return mBid; };
		inline Goodness		GetGoodness() { return mGoodness; };

		inline PackageList 	GetPackageList() { return mPackageList; } ;


		friend int operator > (Move &m1, Move &m2) 
		{	
			return m1.GetGoodness() > m2.GetGoodness(); 
		}

};		
ostream& operator << (ostream& o, Move& m);

#endif
