#ifndef __PACKAGE_H__
#define __PACKAGE_H__

#include "global.h"
#include "Point.h"

class Package {
	private :
		ID					mID;
		Weight				mWeight;
		Point				mLocation, mDestination;
		Robot*				mOwner;
	public :
		Package(ID id) : mID(id),mWeight(0),mOwner(0) {} ;
		Package(ID id, Point location, Weight weight, Point destination): 
				mID(id),mWeight (weight), mLocation(location),mDestination(destination) {} ;
		void SetLocation(Point location) { mLocation = location; };
		void SetDestination(Point destination) { mDestination = destination; };
		void SetOwner(Robot* owner) { mOwner = owner; }
		void SetWeight(Weight weight) { mWeight = weight; }
		inline Point GetLocation () { return mLocation; };
		inline Point GetDestination () { return mDestination; };
		inline Weight GetWeight () { return mWeight; };
		inline ID GetID() { return mID; }
		inline Robot* GetOwner() { return mOwner; } ;
};
ostream& operator << (ostream& o, Package& r);

#endif
