#ifndef __PACKAGES_H__
#define __PACKAGES_H__

#include "global.h"
#include <vector>
#include "Package.h"

class PackageList 
{
private:
	Packages	mPackages;
public:
	Package* 	Find (ID pkgid);
	Package*	Find (Weight weight, bool fuzzy, bool opposite = false);
	Package*	Find (Point location, bool fuzzy, bool opposite = false);
	Package* 	Add (Package *);
	void 		Remove (Package *);
	void 		RemoveAll () { mPackages.clear(); };
	Packages	GetPackages() { return mPackages; };
	Weight		GetWeight();
	Point		GetDestination();
	Index		Size();
};
ostream& operator << (ostream& o, PackageList& p);

#endif
