#ifndef __LOCATION_H__
#define __LOCATION_H__

#include <iostream.h>
#include "global.h"

class Point
{
	private :
		Coordinate mX, mY;
	public :
		Point (): mX(0), mY(0) { };
		Point (int x,int y) : mX(x), mY(y) { };
		int GetX() { return mX; } ;
		int GetY() { return mY; } ;
		void SetX(int x) { mX = x; };
		void SetY(int y) { mY = y; };
		static inline unsigned int Distance (Point & p1, Point & p2) 
			{ return abs(p1.GetX() - p2.GetX()) + abs(p1.GetY() - p2.GetY()); };
		inline unsigned int Distance (Point & p1)
			{ return abs(p1.GetX() - this->GetX()) + abs(p1.GetY() - this->GetY()); };

		friend int operator == (Point & l1, Point& l2) 
			{ if ((l1.mX == l2.mX) && (l1.mY == l2.mY)) return true; return false; };
		friend int operator == (const Point & l1, const Point& l2) 
			{ if ((l1.mX == l2.mX) && (l1.mY == l2.mY)) return true; return false; };
};
ostream& operator << (ostream& o, Point& l);
Point operator - (Point &p1, Point &p2);

#endif
