#ifndef __ROBOT_H__
#define __ROBOT_H__

#include "PackageList.h"
#include "MoveList.h"

class Robot 
{
	private:
		ID					mID;
		Point				mLocation;
		PackageList			mPackageList;
		MoveList			mLastMoves;
		Weight				mMaximumCapacity, mCurrentPayload;
		Money				mBalance;
		Score				mPoints;
		Move				mNextMove;
		MoveList			mMoveList;
	protected:
		MoveList			Think (Game *);
		Move				Decide(Game *, MoveList);
		void				Rate (Game *, Move *);
	public:
		Robot(ID id, Point location, Weight weight = 0, Money balance = 0) : mID(id), 
				mLocation(location), mMaximumCapacity (weight), mCurrentPayload(0), mBalance(balance),
				mPoints (0) {};
			
		ID GetID() { return mID; }
		Point GetLocation() { return mLocation; }
		PackageList GetPackageList() { return mPackageList; }

		void SetID(ID id) { mID = id; };
		void SetLocation(Point location) { mLocation = location; } ;

		Package* Update (MoveType, Package*);
		void Update(MoveType move);

		void MakeMove(Game *);
		~Robot() { } ;

		friend int operator == (Robot & r1,Robot & r2) { if (r1.mID == r2.mID) return true; return false; };
};
ostream& operator << (ostream& o, Robot& r);
ostream& operator << (ostream& o, Robot* r);

#endif
