#ifndef __SPARSE_ARRAY__
#define __SPARSE_ARRAY__

#include "global.h" 
#include "Point.h"

class SparseArray
{
protected:
		vector<TileType> mValues;
		vector<int> mRowIndices;
		vector<int> mColIndices;

		int FindIndex(int x, int y)
		{
				unsigned int i;
				for( i = 0; i < mRowIndices.size(); i++)
				{
						if(mRowIndices[i] == x && mColIndices[i] == y)
								return i;
				}

				return -1;
		}
public:
		SparseArray() {}
		~SparseArray() {}
		vector<Point* > Find(TileType tile)
		{
			vector<Point *> points;
			for (Index i = 0; i < mValues.size(); i++)
			{
				if (mValues[i] == tile)
					points.push_back(new Point(mRowIndices[i],mColIndices[i]));
			}
			return points;
		}
		void Set(int x, int y, TileType val)
		{
			if(val != PLAIN)
			{
				int index = FindIndex(x, y);
				if(index != -1)
						mValues[index] = val;
				else
				{
					mValues.push_back(val);
					mRowIndices.push_back(x);
					mColIndices.push_back(y);
				}
			}
		}

		void DumpArray()
		{
			for(Index i = 0; i < mValues.size(); i++)
			{
			}
		}
		int Get(int x, int y)
		{
				int index = FindIndex(x, y);
				if(index == -1)
						return PLAIN;
				else
				{
						return mValues[index];
				}
		}
};
#endif
